/* Generated by wayland-scanner 1.20.0 */

#ifndef ZWP_WWW_CLIENT_PROTOCOL_H
#define ZWP_WWW_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_zwp_www The zwp_www protocol
 * @section page_ifaces_zwp_www Interfaces
 * - @subpage page_iface_www - 
 * - @subpage page_iface_www_surface - 
 */
struct wl_surface;
struct www;
struct www_surface;

#ifndef WWW_INTERFACE
#define WWW_INTERFACE
/**
 * @page page_iface_www www
 * @section page_iface_www_api API
 * See @ref iface_www.
 */
/**
 * @defgroup iface_www The www interface
 */
extern const struct wl_interface www_interface;
#endif
#ifndef WWW_SURFACE_INTERFACE
#define WWW_SURFACE_INTERFACE
/**
 * @page page_iface_www_surface www_surface
 * @section page_iface_www_surface_api API
 * See @ref iface_www_surface.
 */
/**
 * @defgroup iface_www_surface The www_surface interface
 */
extern const struct wl_interface www_surface_interface;
#endif

#define WWW_CREATE 0


/**
 * @ingroup iface_www
 */
#define WWW_CREATE_SINCE_VERSION 1

/** @ingroup iface_www */
static inline void
www_set_user_data(struct www *www, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) www, user_data);
}

/** @ingroup iface_www */
static inline void *
www_get_user_data(struct www *www)
{
	return wl_proxy_get_user_data((struct wl_proxy *) www);
}

static inline uint32_t
www_get_version(struct www *www)
{
	return wl_proxy_get_version((struct wl_proxy *) www);
}

/** @ingroup iface_www */
static inline void
www_destroy(struct www *www)
{
	wl_proxy_destroy((struct wl_proxy *) www);
}

/**
 * @ingroup iface_www
 *
 */
static inline struct www_surface *
www_create(struct www *www, struct wl_surface *surface)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) www,
			 WWW_CREATE, &www_surface_interface, wl_proxy_get_version((struct wl_proxy *) www), 0, NULL, surface);

	return (struct www_surface *) id;
}

/**
 * @ingroup iface_www_surface
 * @struct www_surface_listener
 */
struct www_surface_listener {
	/**
	 * Status update on a www_surface
	 *
	 * 
	 */
	void (*status)(void *data,
		       struct www_surface *www_surface,
		       int32_t x_rel,
		       int32_t y_rel,
		       uint32_t timestamp);
	/**
	 * Drag has started
	 *
	 * 
	 */
	void (*start_drag)(void *data,
			   struct www_surface *www_surface);
	/**
	 * Drag has ended
	 *
	 * 
	 */
	void (*end_drag)(void *data,
			 struct www_surface *www_surface);
};

/**
 * @ingroup iface_www_surface
 */
static inline int
www_surface_add_listener(struct www_surface *www_surface,
			 const struct www_surface_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) www_surface,
				     (void (**)(void)) listener, data);
}

#define WWW_SURFACE_DESTROY 0

/**
 * @ingroup iface_www_surface
 */
#define WWW_SURFACE_STATUS_SINCE_VERSION 1
/**
 * @ingroup iface_www_surface
 */
#define WWW_SURFACE_START_DRAG_SINCE_VERSION 1
/**
 * @ingroup iface_www_surface
 */
#define WWW_SURFACE_END_DRAG_SINCE_VERSION 1

/**
 * @ingroup iface_www_surface
 */
#define WWW_SURFACE_DESTROY_SINCE_VERSION 1

/** @ingroup iface_www_surface */
static inline void
www_surface_set_user_data(struct www_surface *www_surface, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) www_surface, user_data);
}

/** @ingroup iface_www_surface */
static inline void *
www_surface_get_user_data(struct www_surface *www_surface)
{
	return wl_proxy_get_user_data((struct wl_proxy *) www_surface);
}

static inline uint32_t
www_surface_get_version(struct www_surface *www_surface)
{
	return wl_proxy_get_version((struct wl_proxy *) www_surface);
}

/**
 * @ingroup iface_www_surface
 *
 */
static inline void
www_surface_destroy(struct www_surface *www_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) www_surface,
			 WWW_SURFACE_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) www_surface), WL_MARSHAL_FLAG_DESTROY);
}

#ifdef  __cplusplus
}
#endif

#endif
